#include <string>
#include "CodeBeautifier.h"
#include "PythonInterface.h"
#include "AStyle/astyle_main.h"

using namespace std;

// allow for different calling conventions in Linux and Windows
#ifdef _WIN32
#define STDCALL __stdcall
#else
#define STDCALL
#endif

// Error handler for the Artistic Style formatter.
void  STDCALL ASErrorHandler(int errorNumber, const char* errorMessage)
{
    cout << "astyle error " << errorNumber << "\n"
        << errorMessage << endl;
}

// Allocate memory for the Artistic Style formatter.
char* STDCALL ASMemoryAlloc(unsigned long memoryNeeded)
{
    // error condition is checked after return from AStyleMain
    char* buffer = new(nothrow) char[memoryNeeded];
    return buffer;
}

std::string CodeBeautifier::formatCode(std::string textIn)
{
    return AStyleMain(textIn.c_str(), options.c_str(), ASErrorHandler, ASMemoryAlloc);
}

void CodeBeautifier::setOptions(std::string newOptions)
{
    options = newOptions;
}
